-- echo the SIO input and send every second a dot

terminalX = 0
terminalY = 0
green = Color.new(0, 255, 0)
terminal = Image.createEmpty(480, 272)

function scroll(image, dx, dy)
	new = Image.createEmpty(image:width(), image:height())
	new:blit(dx, dy, image)
	return new
end

function printTerminal(text)
	for i = 1, string.len(text) do
		char = string.sub(text, i, i)
		if char == "\n" then
			terminalY = terminalY + 1
			terminalX = 0
		else
			terminal:print(terminalX * 8, terminalY * 8, char, green)
			terminalX = terminalX + 1
			if terminalX >= 60 then
				terminalX = 0
				terminalY = terminalY + 1
			end
		end
		if terminalY >= 34 then
			terminalY = 33
			terminal = scroll(terminal, 0, -8)
		end
	end
end

function normalizeLinefeed(text)
	result = ""
	for i = 1, string.len(text) do
		char = string.sub(text, i, i)
		if char == "\r" then char = "\n" end
		result = result .. char
	end
	return result
end

System.sioInit(2400)
infoString = "--- PSP Test Terminal ---\n"
printTerminal(infoString);
System.sioWrite(infoString)
while true do
	pad=Controls.read()
	if pad:start()    then break end
	if pad:circle()   then System.sioWrite("O") end
	if pad:square()   then System.sioWrite("#") end
	if pad:cross()    then System.sioWrite("X") end
	if pad:triangle() then System.sioWrite("A") end
	text = normalizeLinefeed(System.sioRead())
	printTerminal(text)
	--- System.sioWrite(text)
	screen:blit(0,0,terminal, 0,0,terminal:width(),terminal:height(),false)
	screen.waitVblankStart()
	screen:flip()
end
